#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>

#define pi  3.141592654

char nibbles[4];
FILE *DACfp,*BASICWAVEfp,*TRIWAVEfp,*TRAPEZWAVEfp;
FILE *SQWAVEfp,*EGUITWAVEfp,*EXPWAVEfp;

void calcTri(int);
void calcTrapez(int);

int main(int argc, char *argv[])
{
signed int yWave;
float arg,yFl,freq;
int K, L, N, SLOPE;

	if((DACfp = fopen("DACDATA.TXT", "w")) == NULL)  {
		printf("cannot generate file DACDATA.TXT");
		exit(1);
	}
	if((BASICWAVEfp = fopen("BASICWAVE.SYX", "wb")) == NULL)  {
		printf("cannot generate file BASICWAVE.SYX");
		exit(1);
	}
	if((TRIWAVEfp = fopen("TRIWAVE.SYX", "wb")) == NULL)  {
		printf("cannot generate file TRIWAVE.SYX");
		exit(1);
	}	
	if((TRAPEZWAVEfp = fopen("TRAPEZWAVE.SYX", "wb")) == NULL)  {
		printf("cannot generate file TRAPEZWAVE.SYX");
		exit(1);
	}	
	if((SQWAVEfp = fopen("SQUAREWAVE.SYX", "wb")) == NULL)  {
		printf("cannot generate file SQUAREWAVE.SYX");
		exit(1);
	}
	if((EGUITWAVEfp = fopen("EGUITWAVE.SYX", "wb")) == NULL)  {
		printf("cannot generate file EGUITWAVE.SYX");
		exit(1);
	}	
	if((EXPWAVEfp = fopen("EXPWAVE.SYX", "wb")) == NULL)  {
		printf("cannot generate file EXPWAVE.SYX");
		exit(1);
	}
	
// Generation of sine wave amplitude values
  	fprintf(DACfp,"\n\n//14 bit resolution DAC data for SINUS with 1024 steps");
    
    fputc(0xF0,BASICWAVEfp);
    fputc(0x7D,BASICWAVEfp);
    fputc(0x40,BASICWAVEfp);
    fputc(0,BASICWAVEfp);
    
  	L = 0;
  	for (K=0;K<1024;K++)  {
        if (L==0)  {
			fprintf(DACfp,"\n");
		}
		arg = K*2*pi/1024;
		yFl =sinf(arg);
		yWave = (signed short int)(yFl*8192);
		if (yWave >8192) yWave=8192;
		if (yWave < -8192) yWave= -8192;
		
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,BASICWAVEfp);
 	        
        if (L==7)  {
 	        fprintf(DACfp,"0x%hX,",yWave);
			L = 0;
		}
        else  {
  			fprintf(DACfp,"0x%hx,",yWave);
			L++;
		}
	}  //end K
    fputc(0xF7,BASICWAVEfp);
    
  	fprintf(DACfp,"\n\n//14 bit resolution DAC data for TRISQUARE with 1024 steps");
  	             
    fputc(0xF0,BASICWAVEfp);
    fputc(0x7D,BASICWAVEfp);
    fputc(0x40,BASICWAVEfp);
    fputc(1,BASICWAVEfp);
          
  	L = 0;
  	for (K=0;K<1024;K++)  {    
        if (L==0)  {
			fprintf(DACfp,"\n");
		}
        if (K < 32)   {   // 8-th wave rising 
			yWave = K * 256;
        }	

        else if (K <= 511)   {   // 25% square 100% level
			yWave=8191;
        }
        else if ((K > 511) && (K < 514)) yWave = 0;          
        else if (K < 992 )   {  // 25% square -100% level
			 yWave= -8192;
        }
        else  {   // K >= steps *3/4   negative 8-th wave rising
              yWave = -(1023-K)*256;        
        }
        if  (yWave < -8192) yWave = -8192;
        if (yWave>=8192) yWave = 8191;
		
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,BASICWAVEfp);
 	    
        fprintf(DACfp,"0x%hX,",yWave);   	
        if (L==7) L = 0;
        else  L++;
	}  //end K
    fputc(0xF7,BASICWAVEfp);
    
  	fprintf(DACfp,"\n\n//14 bit resolution DAC data for Hard Trapezoidal with 1024 steps");
  	        
    fputc(0xF0,BASICWAVEfp);
    fputc(0x7D,BASICWAVEfp);
    fputc(0x40,BASICWAVEfp);
    fputc(2,BASICWAVEfp);
    
  	L = 0;
  	for (K=0;K<1024;K++)  {    
        if (L==0)  {
			fprintf(DACfp,"\n");
		}
      if (K < 24)   {   // 25% square 100% level
			yWave = K * 384;
        }	

        else if (K <= 488)   {   // 25% square 100% level
			yWave=8191;
        }
        else if (K < 536 )   {   // (37,5 to 62,5)% falling
			yWave= 8192 + 384 *(488 - K);
        }
        else if (K < 1008 )   {  // 25% square -100% level
			 yWave= -8192;
        }
        else  {   // K >= steps *3/4   negative 8-th wave  rising
              yWave = -(1023-K)*384;        
        }
        if  (yWave < -8192) yWave = -8192;
        if (yWave>=8192) yWave = 8191;
		
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,BASICWAVEfp);
 	       	
        fprintf(DACfp,"0x%hX,",yWave);   	
        if (L==7) L = 0;
        else  L++;
	}  //end K
    fputc(0xF7,BASICWAVEfp);
            

  	fprintf(DACfp,"\n\n//14 bit resolution DAC data for TRAPEZOIDAL with 1024 steps");
  	        
    fputc(0xF0,BASICWAVEfp);
    fputc(0x7D,BASICWAVEfp);
    fputc(0x40,BASICWAVEfp);
    fputc(3,BASICWAVEfp);
    
  	L = 0;
  	for (K=0;K<1024;K++)  {    
        if (L==0) fprintf(DACfp,"\n");
		
        if (K < 64)   {   // 8-th ave rising
			yWave = K * 131072;
			yWave = yWave/1024 + 8192;  
        }
        else if (K <= 448 )   {  // (12,5 to 37,5)% square 100% level
			yWave=16383;
        }
        else if (K < 576 )   {   // (37,5 to 62,5)% falling
			yWave= 128 *(1024 - K) - 57344; //57344 + 24576;
        }
        else if (K < 969 )   {  // 62,5to 93,75)% square -100% level
			 yWave= 0;
        }
        else  {   // K >= steps *15/16   negative 16-th wave rising
        yWave = -(1023 - K)*128 + 8192;
              
        }
        yWave -= 8192;
        if  (yWave < -8192) yWave = -8192;
        if (yWave>=8192) yWave = 8191;
		
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,BASICWAVEfp);
 	       
        fprintf(DACfp,"0x%hX,",yWave);   	
        if (L==7) L = 0;
        else  L++;
	}  //end K
    fputc(0xF7,BASICWAVEfp);

// Generation of triangle wave amplitude values
    for (N=0; N<4; N++)  {
        if (N == 0) SLOPE = 511;
        else if (N == 1) SLOPE =480;
        else if (N == 2) SLOPE = 472;
        else SLOPE = 464;         
        fputc(0xF0,TRIWAVEfp);
        fputc(0x7D,TRIWAVEfp);
        fputc(0x40,TRIWAVEfp);
        fputc(N,TRIWAVEfp);
        calcTri(SLOPE);
        fputc(0xF7,TRIWAVEfp);       
    }

// Generation of trapez wave amplitude values
    for (N=0; N<4; N++)  {
        
        if (N == 0) SLOPE = 36;
        else if (N == 1) SLOPE = 40;
        else if (N == 2) SLOPE = 44;
        else SLOPE = 48;                        
        fputc(0xF0,TRAPEZWAVEfp);
        fputc(0x7D,TRAPEZWAVEfp);
        fputc(0x40,TRAPEZWAVEfp);
        fputc(N,TRAPEZWAVEfp);
        calcTrapez(SLOPE);
        fputc(0xF7,TRAPEZWAVEfp);       
    }
   
  	fprintf(DACfp,"\n\n//14 bit resolution DAC data for 50%% Square Wave with 1024 steps ");
    
    fputc(0xF0,SQWAVEfp);
    fputc(0x7D,SQWAVEfp);
    fputc(0x40,SQWAVEfp);
    fputc(0,SQWAVEfp);
    
  	L = 0;
  	for (K=0;K < 1024;K++)  {    
        if (L==0) fprintf(DACfp,"\n");

		if ( K < 2) yWave =  0;
        else if (K <= 511 ) yWave = 8191;  //0x1FFF
        else if ((K > 511) && (K < 514)) yWave = 0;
        else  yWave = -8192;  //0xE000
        
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,SQWAVEfp);
             	
        fprintf(DACfp,"0x%hX,",yWave);   	
        if (L==7) L = 0;
        else  L++;
	}  //end K
    fputc(0xF7,SQWAVEfp);
    			
  	fprintf(DACfp,"\n\n//14 bit resolution DAC data for 30%% Square Wave with 1024 steps ");
    
    fputc(0xF0,SQWAVEfp);
    fputc(0x7D,SQWAVEfp);
    fputc(0x40,SQWAVEfp);
    fputc(1,SQWAVEfp);
    
  	L = 0;
  	for (K=0;K < 1024;K++)  {    
        if (L==0) fprintf(DACfp,"\n");

		if ( K < 2) yWave =  0;
        else if (K <= 306 ) yWave = 11468;  //0x2CCC
        else if ((K > 306) && (K < 309)) yWave = 0;
        else  yWave = -4915;  //0xECCD
        
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,SQWAVEfp);
   	
        fprintf(DACfp,"0x%hX,",yWave);   	
        if (L==7) L = 0;
        else  L++;
	}  //end K
    fputc(0xF7,SQWAVEfp);
                   
  	fprintf(DACfp,"\n\n//14 bit resolution DAC data for 20%% Square Wave with 1024 steps ");
    
    fputc(0xF0,SQWAVEfp);
    fputc(0x7D,SQWAVEfp);
    fputc(0x40,SQWAVEfp);
    fputc(2,SQWAVEfp);
    
  	L = 0;
  	for (K=0;K < 1024;K++)  {    
        if (L==0) fprintf(DACfp,"\n");

		if ( K < 2) yWave =  0;
        else if (K <= 203 ) yWave = 13106;  //0x3332
        else if ((K > 203) && (K < 206)) yWave = 0;
        else  yWave = -3277;  //0xF2CF
        
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,SQWAVEfp);
   	
        fprintf(DACfp,"0x%hX,",yWave);   	
        if (L==7) L = 0;
        else  L++;
	}  //end K
    fputc(0xF7,SQWAVEfp);
    		
  	fprintf(DACfp,"\n\n//14 bit resolution DAC data for 10%% Square Wave with1024 steps ");
    
    fputc(0xF0,SQWAVEfp);
    fputc(0x7D,SQWAVEfp);
    fputc(0x40,SQWAVEfp);
    fputc(3,SQWAVEfp);
    
  	L = 0;
  	for (K=0;K < 1024;K++)  {    
        if (L==0)  fprintf(DACfp,"\n");
	
		if ( K < 2) yWave =  0;
        else if (K <= 101 ) 	yWave = 14745;  //0x3999
        else if ((K > 101) && (K < 104)) yWave = 0; 
        else  yWave = - 1638; //0xF99A
        
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,SQWAVEfp);
   	
        fprintf(DACfp,"0x%hX,",yWave);   	
        if (L==7) L = 0;
        else  L++;
	}  //end K
    fputc(0xF7,SQWAVEfp);

// Generation of electric Guitar similar wave amplitude values

// Shape and frequency of the burst at the wave start
// is essentially guitar characteristic (body, pickup, tone filter)
// and usually not pure harmonics of the played note pitch
// i.e. the exact wave shape varies from note to note.
// Because realtime calculation based on guitar characteristics takes
// too much CPU time, a simplified model based on note pitch harmonics
// is used here. Sounds more sweet and less typical than a real guitar.

  	fprintf(DACfp,"\n\n//14 bit resolution DAC data for E-Guitar simulation with 1024 steps");
    fprintf(DACfp,"\n//Burst with 2 oscillations of 4th harmonic");	
    
    fputc(0xF0,EGUITWAVEfp);
    fputc(0x7D,EGUITWAVEfp);
    fputc(0x40,EGUITWAVEfp);
    fputc(0,EGUITWAVEfp);
    
  	L = 0;
  	for (K=0;K<1024;K++)  {
        if (L==0)  {
			fprintf(DACfp,"\n");
		}
        arg = 4* (K*2*pi/1024);                      //4th harmonic,
        yFl =sinf(arg);
        
		if (K < 128) {
           yWave = (signed short int)(yFl*7022);    // 3/7 amplitude
        }
		else if (K < 256) {
           yWave = (signed short int)(yFl*9362);    // 4/7 amplitude
        }
		else if (K < 384) {
           yWave = (signed short int)(yFl*4687);    // 2/7 amplitude
        }
		else if (K < 512) {
           yWave = (signed short int)(yFl*2340);    // 1/7 amplitude
        }       
        else yWave = 0;
		
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,EGUITWAVEfp);
 	        
        if (L==7)  {
 	        fprintf(DACfp,"0x%hX,",yWave);
			L = 0;
		}
        else  {
  			fprintf(DACfp,"0x%hx,",yWave);
			L++;
		}
	}  //end K
    fputc(0xF7,EGUITWAVEfp);


  
  	fprintf(DACfp,"\n\n//14 bit resolution DAC data for E-Guitar simulation with 1024 steps");
    fprintf(DACfp,"\n//Burst with 3 oscillations of 5th harmonic");	    
    fputc(0xF0,EGUITWAVEfp);
    fputc(0x7D,EGUITWAVEfp);
    fputc(0x40,EGUITWAVEfp);
    fputc(1,EGUITWAVEfp);
    
  	L = 0;
  	for (K=0;K<1024;K++)  {
        if (L==0)  {
			fprintf(DACfp,"\n");
		}
        arg = 5*(K*2*pi/1024);                      //5th harmonic
        yFl =sinf(arg);
        
		if (K < 102) {
           yWave = (signed short int)(yFl*6144);    // 6/16 amplitude
        }
		else if (K < 205) {
           yWave = (signed short int)(yFl*10240);   // 10/16 amplitude
        }
		else if (K < 307) {
           yWave = (signed short int)(yFl*6144);    // 6/16 amplitude
        }
		else if (K < 410) {
           yWave = (signed short int)(yFl*4096);    // 4/16 amplitude
        }  
		else if (K < 512) {
           yWave = (signed short int)(yFl*3072);    // 3/16 amplitude
        } 
		else if (K < 614) {
           yWave = (signed short int)(yFl*2048);    // 2/16 amplitude
        }      
        else if (K < 717){
           yWave = (signed short int)(yFl*1024);    // 1/16 amplitude
        } 
        else yWave = 0;     
		
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,EGUITWAVEfp);
 	        
        if (L==7)  {
 	        fprintf(DACfp,"0x%hX,",yWave);
			L = 0;
		}
        else  {
  			fprintf(DACfp,"0x%hx,",yWave);
			L++;
		}
	}  //end K
    fputc(0xF7,EGUITWAVEfp);  
 
  	fprintf(DACfp,"\n\n//14 bit resolution DAC data for E-Guitar simulation with 1024 steps");
    fprintf(DACfp,"\n//Burst with 2 oscillations of 3rd harmonic");	    
    fputc(0xF0,EGUITWAVEfp);
    fputc(0x7D,EGUITWAVEfp);
    fputc(0x40,EGUITWAVEfp);
    fputc(2,EGUITWAVEfp);
    
  	L = 0;
  	for (K=0;K<1024;K++)  {
        if (L==0)  {
			fprintf(DACfp,"\n");
		}
        arg = 3*(K*2*pi/1024);                       //3rd harmonic
        yFl =sinf(arg);
        
		if (K < 171) {
           yWave = (signed short int)(yFl*6144);    // 3/8 amplitude
        }
		else if (K < 342) {
           yWave = (signed short int)(yFl*10240);   // 5/8 amplitude
        }
		else if (K < 512) {
           yWave = (signed short int)(yFl*8192);    // 4/8 amplitude
        }
		else if (K < 683) {
           yWave = (signed short int)(yFl*4096);    // 2/8 amplitude
        }  
        else yWave = 0;
		
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,EGUITWAVEfp);
 	        
        if (L==7)  {
 	        fprintf(DACfp,"0x%hX,",yWave);
			L = 0;
		}
        else  {
  			fprintf(DACfp,"0x%hx,",yWave);
			L++;
		}
	}  //end K
    fputc(0xF7,EGUITWAVEfp);    
 
  	fprintf(DACfp,"\n\n//14 bit resolution DAC data for E-Guitar simulation with 1024 steps");
    fprintf(DACfp,"\n//Burst with 2 oscillations of 2nd harmonic");    
    fputc(0xF0,EGUITWAVEfp);
    fputc(0x7D,EGUITWAVEfp);
    fputc(0x40,EGUITWAVEfp);
    fputc(3,EGUITWAVEfp);
    
  	L = 0;
  	for (K=0;K<1024;K++)  {
        if (L==0)  {
			fprintf(DACfp,"\n");
		}
        arg = 2*(K*2*pi/1024);                       //2nd harmonic
        yFl =sinf(arg);
        
		if (K < 256) {
           yWave = (signed short int)(yFl*8182);    // 4/8 amplitude
        }
		else if (K < 512) {
           yWave = (signed short int)(yFl*10240);   // 5/8 amplitude
        }
		else if (K < 768) {
           yWave = (signed short int)(yFl*4096);    // 2/8 amplitude
        }
		else {
           yWave = (signed short int)(yFl*1024);    // 1/8 amplitude
        }  
		
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,EGUITWAVEfp);
 	        
        if (L==7)  {
 	        fprintf(DACfp,"0x%hX,",yWave);
			L = 0;
		}
        else  {
  			fprintf(DACfp,"0x%hx,",yWave);
			L++;
		}
	}  //end K
    fputc(0xF7,EGUITWAVEfp);    


    fprintf(DACfp,"\n\n//14 bit resolution DAC data for E-Guitar simulation with 1024 steps");
    fprintf(DACfp,"\n//Burst with exponentially decaying oscillations of 4th harmonic");	    
    fputc(0xF0,EXPWAVEfp);
    fputc(0x7D,EXPWAVEfp);
    fputc(0x40,EXPWAVEfp);
    fputc(0,EXPWAVEfp);
    
  	L = 0;
  	for (K=0;K<1024;K++)  {
        if (L==0)  {
			fprintf(DACfp,"\n");
		}
        arg = 4*(K*2*pi/1024);                      //4th harmonic
        yFl =sinf(arg);
        
		if (K < 128) {
           yWave = (signed short int)(yFl*6144);    // 6/16 amplitude
        }
		else if (K < 256) {
           yWave = (signed short int)(yFl*10240);   // 10/16 amplitude
        }
		else {
              yWave = (signed short int)(exp((256 - K)*0.004) * (yFl*10240));
        }                         //exp(-3) ca. 0.05.level ca.500 at K=1024                       
                                                     
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,EXPWAVEfp);
 	        
        if (L==7)  {
 	        fprintf(DACfp,"0x%hX,",yWave);
			L = 0;
		}
        else  {
  			fprintf(DACfp,"0x%hx,",yWave);
			L++;
		}
	}  //end K
    fputc(0xF7,EXPWAVEfp);
 
    fprintf(DACfp,"\n\n//14 bit resolution DAC data for E-Guitar simulation with 1024 steps");
    fprintf(DACfp,"\n//Burst with exponentially decaying oscillations of 5th harmonic");	    
    fputc(0xF0,EXPWAVEfp);
    fputc(0x7D,EXPWAVEfp);
    fputc(0x40,EXPWAVEfp);
    fputc(1,EXPWAVEfp);
    
  	L = 0;
  	for (K=0;K<1024;K++)  {
        if (L==0)  {
			fprintf(DACfp,"\n");
		}
        arg = 5*(K*2*pi/1024);                      //5th harmonic
        yFl =sinf(arg);
        
		if (K < 102) {
           yWave = (signed short int)(yFl*6144);    // 6/16 amplitude
        }
		else if (K < 205) {
           yWave = (signed short int)(yFl*10240);   // 10/16 amplitude
        }
		else {
              yWave = (signed short int)(exp((205 - K)*0.0045) * (yFl*10240));
        }  //exp(-3.7) ca. 0.025. level ca.250 at K=1024                       
                                                     
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,EXPWAVEfp);
 	        
        if (L==7)  {
 	        fprintf(DACfp,"0x%hX,",yWave);
			L = 0;
		}
        else  {
  			fprintf(DACfp,"0x%hx,",yWave);
			L++;
		}
	}  //end K
    fputc(0xF7,EXPWAVEfp);
    
    fprintf(DACfp,"\n\n//14 bit resolution DAC data for E-Guitar simulation with 1024 steps");
    fprintf(DACfp,"\n//Burst with exponentially decaying oscillations of 6th harmonic");	    
    fputc(0xF0,EXPWAVEfp);
    fputc(0x7D,EXPWAVEfp);
    fputc(0x40,EXPWAVEfp);
    fputc(2,EXPWAVEfp);
    
  	L = 0;
  	for (K=0;K<1024;K++)  {
        if (L==0)  {
			fprintf(DACfp,"\n");
		}
        arg = 6*(K*2*pi/1024);                      //6th harmonic
        yFl =sinf(arg);
        
		if (K < 85) {
           yWave = (signed short int)(yFl*6144);    // 6/16 amplitude
        }
		else if (K < 171) {
           yWave = (signed short int)(yFl*10240);   // 10/16 amplitude
        }
		else {
              yWave = (signed short int)(exp((171 - K)*0.0027) * (yFl*10240));
        }  //exp(-2.3) ca. 0.1. level ca.1024 at K=1024                       
                                                     
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,EXPWAVEfp);
 	        
        if (L==7)  {
 	        fprintf(DACfp,"0x%hX,",yWave);
			L = 0;
		}
        else  {
  			fprintf(DACfp,"0x%hx,",yWave);
			L++;
		}
	}  //end K
    fputc(0xF7,EXPWAVEfp);

    fprintf(DACfp,"\n\n//14 bit resolution DAC data for E-Guitar simulation with 1024 steps");
    fprintf(DACfp,"\n//Burst with exponentially decaying oscillations of 7th harmonic");	    
    fputc(0xF0,EXPWAVEfp);
    fputc(0x7D,EXPWAVEfp);
    fputc(0x40,EXPWAVEfp);
    fputc(3,EXPWAVEfp);
    
  	L = 0;
  	for (K=0;K<1024;K++)  {
        if (L==0)  {
			fprintf(DACfp,"\n");
		}
        arg = 7*(K*2*pi/1024);                      //7th harmonic
        yFl =sinf(arg);
        
		if (K < 73) {
           yWave = (signed short int)(yFl*6144);    // 6/16 amplitude
        }
		else if (K < 146) {
           yWave = (signed short int)(yFl*10240);   // 10/16 amplitude
        }
		else {
              yWave = (signed short int)(exp((146 - K)*0.00524) * (yFl*10240));
        }  //exp(-4.6) ca. 0.01. level ca.100 at K=1024                       
                                                     
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,EXPWAVEfp);
 	        
        if (L==7)  {
 	        fprintf(DACfp,"0x%hX,",yWave);
			L = 0;
		}
        else  {
  			fprintf(DACfp,"0x%hx,",yWave);
			L++;
		}
	}  //end K
    fputc(0xF7,EXPWAVEfp);
                      
   	fclose(DACfp);
	fclose(BASICWAVEfp);	
	fclose(TRIWAVEfp);
	fclose(TRAPEZWAVEfp);
    fclose(SQWAVEfp);
    fclose(EGUITWAVEfp);
    fclose(EXPWAVEfp);
   	printf("\nfile BASICWAVE.SYX (4 waves) generated");
	printf("\nfile TRIWAVE.SYX (4 waves) generated");
	printf("\nfile TRAPEZWAVE.SYX (4 waves) generated");
    printf("\nfile SQUAREWAVE.SYX (4 waves) generated");      
	printf("\nfile EGUITWAVE.SYX (4 waves) generated");   
	printf("\nfile EXPWAVE.SYX (4 waves) generated");      	
	printf("\nfile DACDATA.TXT generated\n");
	printf("\nPress any key to leave the app\n");
	printf("\n");
    while(! kbhit());
  	return 0;
}


void calcTri(int slope)  // *************************************************
// slope < 256 : fast rise to 8192, slow fall to -8192, fast rise to 0
// slope == 256 : symmetric triangle
// slope > 256 : slow rise to 8192, fast fall to -8192, slow rise to 0
// slope=2 or slope=511: sawtooth
// **************************************************************************
{
signed int yWave, delta, gradient_p, gradient_m;
int k, L;    
 
    if (slope < 2) slope = 2;
    if (slope > 511) slope = 511;
    fprintf(DACfp,"\n\n//14 bit DAC data for TRIANGLE with 1024 steps, slope=%d/%d steps",slope,512-slope);    
  	L = 0;
  	delta = 1024 - slope*2;
  	gradient_p = 8192/slope;
  	gradient_m = 16384/(1024 - 2*slope);  	
  	
   	for (k=0;k<1024;k++)  {    
        if (L==0)  {
			fprintf(DACfp,"\n");
		}
        if (k < slope)   {   // from 0 up tp 100% level
	//		fWave =  8191.0 * (float)(k/slope);
			yWave = k * gradient_p;
        }	
        else if ((k >= slope) && (k <= (1024-slope))) { //from 100% down to -100%
            yWave = 8192 - gradient_m * (k - slope);
        }
        else   { //(K >= 1023 - slope ) from -100% up to 0
	        yWave = (k-1024) * gradient_p;
        }
        if  (yWave < -8192) yWave = -8192;
        if (yWave>=8192) yWave = 8191;
		
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,TRIWAVEfp);
 	       	
        fprintf(DACfp,"0x%hX,",yWave);   	
        if (L==7) L = 0;
        else  L++;
	}  //end k     
}     

void calcTrapez(int slope)  // **********************************************
// slope<256: rise to 8191,stay at 8191,fall to -8192, stay at -8182,rise to 0
// extreme case slope == 256 : symmetric triangle
// extreme case slope == 1 : 50% square
// **************************************************************************
{
signed int yWave, delta, gradient_p, gradient_m;
int k, L;    
 
    if (slope < 1) slope = 1;
    if (slope > 256) slope = 256;
    fprintf(DACfp,"\n\n//14 bit DAC data for TRAPEZ with 1024 steps, slope=%d steps", slope);    
  	L = 0;
  	delta = 512 - slope;
  	gradient_p = 8192/slope;
  	gradient_m = 16384/slope;  	
  	
   	for (k=0;k<1024;k++)  {    
        if (L==0)  {
			fprintf(DACfp,"\n");
		}
		if ((k == 0) || (k==512)) yWave = 0;
        else if (k < slope)   {   // from 0 up tp 100% level
			yWave = k * gradient_p;
        }	
        else if ((k >= slope) && (k < (512 - slope))) { //stay at 100%
            yWave = 8191;
        }        
        else if ((k >= (512 - slope)) && (k < (512 + slope))) { //from 100% down to -100%
            yWave = 8191 - gradient_p * (k - 512 + slope);
        }
        else if ((k < (512 + slope)) && (k < (1023 - slope))) { //stay at -100%
            yWave = -8192;
        }
        else   { //(K >= 1023 - slope ) from -100% up to 0
	        yWave = (k-1024) * gradient_p;
        }
        if  (yWave < -8192) yWave = -8192;
        if (yWave>=8192) yWave = 8191;
		
		nibbles[0] = (char)((yWave >> 12)&0x0F);
		nibbles[1] = (char)((yWave >> 8)&0x0F);			
        nibbles[2] = (char)((yWave >> 4)&0x0F);  
        nibbles[3] = (char)(yWave&0x0F);  
        fwrite(&nibbles[0], sizeof(char),4,TRAPEZWAVEfp);
 	       	
        fprintf(DACfp,"0x%hX,",yWave);   	
        if (L==7) L = 0;
        else  L++;
	}  //end k     
}     
